/* John F. Douglass

section: VC
 * CSE142, Spring 1999
 * Homework 4
 * Traffic animation

  STARTER PROGRAM

 *
 *
 */


#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* 
	* <time.h> is included so the current time can be accessed
	* to initialize the random number generator.  If you don't
	* use random numbers (and you don't have to) you can either
	* ignore this #include or delete it.
	*/

/* Logical constants */
#define TRUE    		1
#define FALSE   		0

/* 
 * For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.  The
 * constant FILL is used in function calls when a solid
 * shape is desired.
 */
#define FILL 0


/*
 * Symbolic constants.  Change as needed.
 */

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	75

/* Number of buttons */
#define NUM_BUTTON		8


/* Possible locations of mouse clicks: */

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0


/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10


/* Maximum number of vehicles that can appear in the animation */
#define MAX_VEHICLES	10

/* Height and width of a single car */
#define CAR_HEIGHT 24
#define CAR_WIDTH  40

/* Initial position of the smoke */
#define SMOKE_Y_INITIAL GP142_YMAX/2;

/* Number of windows in the space needle saucer */
#define NUMBER_WINDOWS	9


/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
void initialize_random_numbers();

/* Draw the background, including the sun at coordinates sun_x and sun_y 
as well as the saucer at saucer_x and smoke at smoke_y*/
void draw_landscape(int sun_x, int sun_y, int smoke_x, int smoke_y, 
					int eruption, int evacuate, int saucer_x);

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int *traffic_moving, int car_speed[],
				   int car_direction[], int car_color[], int *eruption, 
				   int *evacuate);

/* Update sun coordinates sun_x, sun_y for one tick */
void move_sun(int *sun_x, int *sun_y);

/* update the location of the smoke */
void move_smoke(int *smoke_y);

/* update the location of the space needle saucer */
void move_saucer(int *saucer_x);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(int car_x[], int car_y[], int direction[], int speed[]);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int car_x[], int car_y[], int color[]);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int car_x[], int car_y[], int color[]);

/* Display error message if internal error is detected. */
void something_is_wrong (void);


/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/

	/* Information about the sun: */
	int sun_x, sun_y;			/* screen x and y coordinates */

	/* information about the smoke */
	int smoke_x, smoke_y;		/* screen x and y coordinates */
	
	/* information about the saucer position */
	int saucer_x=0;		/* screen x and y coodinates */

	/* Information about vehicles in the animation:							*/

	int car_x[MAX_VEHICLES]; 	/* current position of each car					*/
	int car_y[MAX_VEHICLES];
	int car_direction[MAX_VEHICLES];	/* current direction: +1=right, -1=left			*/
	int car_color[MAX_VEHICLES];			/* color of the car								*/
	int car_speed[MAX_VEHICLES];	/* speed in pixels per tick when traffic moving	*/	
	int traffic_moving;						/* = "traffic is currently moving"				*/
	int eruption = FALSE;					/* controls whether or not Mt. Ranier erupts	*/
	int evacuate = FALSE;					/* controls whether or not saucer detaches		*/
	int i;									/* subscript for car property arrays			*/
	

	initialize_random_numbers();
	
	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* set initial location of the sun */
	sun_x = GP142_XMAX - 50;
	sun_y = GP142_YMAX - 35;

	/* set initial location of smoke from Mt. Ranier */ 
	smoke_x = GP142_XMAX-GP142_XMAX;
	smoke_y = GP142_YMAX/2;

	/* set initial conditions for the car */
	for(i=0; i<MAX_VEHICLES; i++){
		car_x[i] = 30*i;
		car_color[i] = RED+i;
		car_speed[i] = i;
		car_direction[i] = i-MAX_VEHICLES/2;/* '+' to the right, '-' to left */
		if(car_direction[i] < 0)
			car_y[i] = HIGHWAY_CENTER+5;
		else
			car_y[i] = HIGHWAY_CENTER-8;}
		traffic_moving = TRUE;
	
	/* Draw initial landscape, buttons, and traffic */
	draw_landscape(sun_x,sun_y,smoke_x,smoke_y,eruption,evacuate,saucer_x);
	draw_buttons( );
	draw_traffic(car_x, car_y, car_color);
	

	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			/* Key pressed.  Not used now.  If the program should		*/
			/* react to keyboard events, insert something appropriate	*/
			/* here.  Note that scanf CANNOT be used with GP142.		*/
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, &traffic_moving, car_speed,
								car_direction, car_color, &eruption, &evacuate);
			} else {
				/* insert code here (and additional else-if statements) */
				/* to react to mouse clicks elsewhere on the screen */
			}
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			move_sun(&sun_x, &sun_y);
			if (eruption)
				move_smoke(&smoke_y);
			if (traffic_moving)
				move_traffic(car_x, car_y, car_direction, car_speed);
			if (evacuate)
				move_saucer(&saucer_x);
			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		/* Redraw everything */
		draw_landscape(sun_x, sun_y, smoke_x, smoke_y, eruption, 
										evacuate, saucer_x);
		draw_buttons();
		draw_traffic(car_x, car_y, car_color);
		
	}  /* end event loop */
	
	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE	

*****************************************************************************/


/* Draw the background, including the sun at coordinates sun_x and sun_y */
void draw_landscape(int sun_x, int sun_y, int smoke_x, int smoke_y, 
								int eruption, int evacuate, int saucer_x)
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text */
	int text_size   = 12;				/* size of text font */
	int i;								/* index for drawing windows in the space needle */
	int j;						/* index for drawing spaces in between windows in needle */ 
										/* horizontal length of windows in the space needle */
	int window_size = 6;	
										/* left width dimension offirst window in needle/saucer */
	int win_left = -2*GP142_XMAX/3-19;	
										/* right width dimension of first window in needle/saucer */
	int win_right = -2*GP142_XMAX/3-13;	
										/* left width dimension of first 'space' after first window*/
	int space_left = -2*GP142_XMAX/3-13;
										/* right width dimension of first space */
	int space_right = -2*GP142_XMAX/3-10;	
								
	/* Draw the sky */
	GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	/* Draw the sun */
	GP142_circleXY(YELLOW, sun_x, sun_y , 20);

	/* draw the smoke */ 
	GP142_circleXY(BLACK, smoke_x, smoke_y, 30);

	/* Draw the ground, highway, and text legend */
	GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);
	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER + HIGHWAY_WIDTH,
					 FILL);

	/* Draw the black line down the center of the highway */
	GP142_rectangleXY(BLACK, -GP142_XMAX, HIGHWAY_CENTER -1,
						GP142_XMAX, HIGHWAY_CENTER + 1, FILL);
	
	GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, text_size,
		"Click a button to control the cars.");
	
	
	/*Draw some mountains */
	
	
	GP142_triangleXY(OLIVE,
		-( 5 * GP142_XMAX/4), HORIZON,
		(GP142_XMAX)/3  , HORIZON,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);
	
	GP142_triangleXY(FOREST_GREEN,
		-GP142_XMAX / 3 , HORIZON,
		GP142_XMAX, HORIZON,
		GP142_XMAX, (2 * GP142_YMAX)/3 ,
		FILL);

	GP142_triangleXY(MED_GRAY,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);

	/* draw lava */
	if(eruption){

		GP142_triangleXY(RED, -GP142_XMAX/10, HORIZON,
			GP142_XMAX/10, HORIZON, 0, (4 * GP142_YMAX)/5, FILL);
		
		GP142_triangleXY(RED, -GP142_XMAX/12-250, HORIZON,
			GP142_XMAX/10-250, HORIZON, 0, (4 * GP142_YMAX)/5, FILL);

		GP142_triangleXY(RED, -GP142_XMAX/12+250, HORIZON,
			GP142_XMAX/10+250, HORIZON, 0, (4 * GP142_YMAX)/5, FILL);}

	/* draw the space needle */

	GP142_triangleXY(WHITE, -2*GP142_XMAX/3, HORIZON-20, -2*GP142_XMAX/3+40,
		HORIZON-20, -2*GP142_XMAX/3+20, GP142_YMAX/3, FILL);

	GP142_triangleXY(BROWN, -2*GP142_XMAX/3+10, HORIZON-20, 
		-2*GP142_XMAX/3+30,	HORIZON-20, -2*GP142_XMAX/3+20, 
		GP142_YMAX/3-50, FILL);

	GP142_triangleXY(MED_GRAY, -2*GP142_XMAX/3+10, HORIZON, -2*GP142_XMAX/3+30,
		HORIZON, -2*GP142_XMAX/3+20, GP142_YMAX/3-50, FILL);

	GP142_rectangleXY(WHITE, -2*GP142_XMAX/3, HORIZON+5, -2*GP142_XMAX/3+40,
		HORIZON+15, FILL);

	GP142_rectangleXY(BLACK, -2*GP142_XMAX/3+2, HORIZON+7, -2*GP142_XMAX/3+10,
		HORIZON+13, FILL);

	GP142_rectangleXY(BLACK, -2*GP142_XMAX/3+15, HORIZON+7, -2*GP142_XMAX/3+25,
		HORIZON+13, FILL);

	GP142_rectangleXY(BLACK, -2*GP142_XMAX/3+30, HORIZON+7, -2*GP142_XMAX/3+38,
		HORIZON+13, FILL);

	GP142_triangleXY(WHITE, -2*GP142_XMAX/3+10, GP142_YMAX/2-20, 
		-2*GP142_XMAX/3+30,GP142_YMAX/2-20, -2*GP142_XMAX/3+20, 
		GP142_YMAX/3-50, FILL);
	
	/* space needle saucer */
	GP142_rectangleXY(WHITE, -2*GP142_XMAX/3+saucer_x, GP142_YMAX/2-20, 
		-2*GP142_XMAX/3+40+saucer_x, GP142_YMAX/2+10, FILL);

	GP142_rectangleXY(WHITE, -2*GP142_XMAX/3-22+saucer_x, GP142_YMAX/2-10, 
		-2*GP142_XMAX/3+62+saucer_x, GP142_YMAX/2, FILL);

	GP142_triangleXY(WHITE,-2*GP142_XMAX/3+19+saucer_x, GP142_YMAX/2+10, 
		-2*GP142_XMAX/3+21+saucer_x, GP142_YMAX/2+10, -2*GP142_XMAX/3+20+saucer_x, 
		GP142_YMAX/2+50, FILL);

	for(i=0; i<NUMBER_WINDOWS; i++){
		
	GP142_rectangleXY(BLACK, win_left+saucer_x, GP142_YMAX/2-8, 
		win_right+saucer_x, GP142_YMAX/2-2, FILL);

	win_left=win_left+9;
	win_right=win_right+9;
	}

	for(j=1; j<NUMBER_WINDOWS; j++){

	GP142_rectangleXY(WHITE, space_left+saucer_x, GP142_YMAX/2-8, 
		space_right+saucer_x, GP142_YMAX/2-2, FILL);

	space_left=space_left+9;
	space_right=space_right+9;
	
	}

	

	




	
	

	

} /*end draw_landscape */



/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons( )
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTON; i++) {
		GP142_rectangleXY(BLACK,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(FOREST_GREEN, text_offset, i, font_size, "Go");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Stop");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "New Color");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Eruption");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Evacuate");
}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTON*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int *traffic_moving, int car_speed[],
				   int car_direction[], int car_color[], int *eruption,
				   int *evacuate)
{
	int buttonNum;		/* number of selected button */
	int i;

	/* Complain if x coordinate couldn't be inside a button */
	if (x < MENU_LEFT || x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	for(i=0; i<MAX_VEHICLES; i++){
	switch(buttonNum) {
	case 0:
		/* go */
		*traffic_moving = TRUE;
		break;
	case 1:
		/* stop */
		*traffic_moving = FALSE;
		break;
		
	case 2:
		/* speed up */
		car_speed[i] = car_speed[i] + 1;
		break;
	case 3:
		/* slow down */
		car_speed[i] = car_speed[i] - 1;
		if (car_speed[i] < 0)
			car_speed[i] = 0;
		break;
		
	case 4:
		/* reverse */
		car_direction[i] = - car_direction[i];
		break;
	case 5:
		/* change car color */
		car_color[i] = (car_color[i]+1) % MAX_COLORS;
		break;
	case 6:
		/* Mt. Ranier erupts */
		*eruption = TRUE;
		break;
	case 7:
		/* space needle saucer detaches */
		*evacuate = TRUE;
		break;
	default:
		/*Bad news if this is ever reached! */
		something_is_wrong();
		break;
	}}
}



/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update sun coordinates sun_x, sun_y by one tick */
void move_sun(int *sun_x, int *sun_y) {
	/* Move the sun to the left.  If it reaches the edge, move it */
	/* to the other side and down a bit. */
	(*sun_x) --;
	if (*sun_x < -GP142_XMAX -30) {
		*sun_x = - *sun_x;
		(*sun_y) --;
	}
}
/* Update smoke coordinates smoke_x, smoke_y by one tick */ 
void move_smoke(int *smoke_y) {
	/* move smoke up, if it reaches the edge move it back to starting point*/
	(*smoke_y) ++;
	if (*smoke_y > GP142_YMAX){
		*smoke_y = SMOKE_Y_INITIAL;
		(*smoke_y) ++;}
}
/* update the coordinates of saucer_x and saucer_y by one tick */
void move_saucer(int *saucer_x){
	/* move saucer up and to the right and eventually off the screen */
	(*saucer_x)++;
}


/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick, */
void move_traffic(int car_x[], int car_y[], int direction[], int speed[]) {
	/* Note: If there is more than one vehicle, this should */
	/* be updated to adjust all vehicle coordinates */

	int i;
	int trial_x;		/* new value for x coordinate */

	/* move vehicle.  If it moves off the edge, reverse direction */
	for(i=0; i<MAX_VEHICLES; i++){
	trial_x = car_x[i] + (direction[i] * speed[i]);
	if ((trial_x) < - GP142_XMAX - CAR_WIDTH/2){
		car_x[i] = GP142_XMAX + CAR_WIDTH/2;}
	else	if (abs(trial_x) > GP142_XMAX + CAR_WIDTH/2){
				car_x[i] = - GP142_XMAX - CAR_WIDTH/2;}
			else car_x[i] = trial_x;
	}
}


/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int car_x[], int car_y[], int color[]) {
	/* Note: needs to be changed if there is more than */
	/* one vehicle */
	int i;
	for(i=0; i<MAX_VEHICLES; i++){
		draw_car(car_x, car_y, color);}
}



/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int car_x[], int car_y[], int color[]) 
{
	int i;
	for(i=0; i<MAX_VEHICLES; i++){
	GP142_rectangleXY(color[i], car_x[i] - CAR_WIDTH/2, car_y[i]+ CAR_HEIGHT/4,
		car_x[i]+CAR_WIDTH/2, car_y[i] + CAR_HEIGHT*3/4, FILL);
	GP142_rectangleXY(color[i], car_x[i] - CAR_WIDTH/6, car_y[i] + CAR_HEIGHT*3/4,
		car_x[i] + CAR_WIDTH/6, car_y[i] + CAR_HEIGHT, FILL);
	GP142_circleXY(BLACK, car_x[i] - CAR_WIDTH/4, car_y[i] + CAR_HEIGHT/4, 
		CAR_HEIGHT/4);
	GP142_circleXY(BLACK, car_x[i] + CAR_WIDTH/4, car_y[i] + CAR_HEIGHT/4, 
		CAR_HEIGHT/4);
	}
}




/*****************************************************************************

     OTHER

*****************************************************************************/


/* Initialize random number generator */
/* [Ignore or delete if your program  */
/* doesn't user random numbers.] */
void initialize_random_numbers() {
	time_t t;			/* current time */
	srand (time(&t));
}



/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}